var ASMAPI = Java.type("net.minecraftforge.coremod.api.ASMAPI");
var Opcodes = Java.type('org.objectweb.asm.Opcodes');
var InsnList = Java.type('org.objectweb.asm.tree.InsnList');
var InsnNode = Java.type('org.objectweb.asm.tree.InsnNode');
var MethodInsnNode = Java.type('org.objectweb.asm.tree.MethodInsnNode');
var VarInsnNode = Java.type('org.objectweb.asm.tree.VarInsnNode');


var METHOD_GETTEXTURE = ASMAPI.mapMethod("func_177334_a");//getDefaultSkin
var METHOD_GETTEXTURE_DESC = "(Ljava/util/UUID;)Lnet/minecraft/util/ResourceLocation;";
				
var NUM_FOUND = 0;


function log(message)
{
    print("[GenderCore-DefaultPlayerSkin]: " + message);
}

function initializeCoreMod()
{
	return {
		"GenderCore-DefaultPlayerSkin": {
			"target": {
				"type": "CLASS",
                'name': 'net.minecraft.client.resources.DefaultPlayerSkin'
			},
			"transformer": function(classNode) {								
                for each (var method in classNode.methods) {					
                    if (method.name.equals(METHOD_GETTEXTURE) && method.desc.equals(METHOD_GETTEXTURE_DESC)) {
                        log("Transforming " + method.name + " in " + classNode.name);
    					NUM_FOUND++;
                        doPatchMethodNodeInClassNode(method);
                    } //else log("Did not match method " + method.name + method.desc + " | target is: "+ METHOD_GETTEXTURE+METHOD_GETTEXTURE_DESC);
                }
                log("Found methods: "+NUM_FOUND+" of 1");
				return classNode;
			}
		}
	};
}

function doPatchMethodNodeInClassNode(method)
{
    var toInject = new InsnList();    
    toInject.add(new VarInsnNode(Opcodes.ALOAD, 0));
	toInject.add(new MethodInsnNode(Opcodes.INVOKESTATIC, "com/github/ipixeli/Gender/sides/client/render/RenderHooks", "getPlayerTexture", "(Ljava/util/UUID;)Lnet/minecraft/util/ResourceLocation;"));
	toInject.add(new InsnNode(Opcodes.ARETURN));
    method.instructions = toInject;
}