var ASMAPI = Java.type("net.minecraftforge.coremod.api.ASMAPI");
var Opcodes = Java.type('org.objectweb.asm.Opcodes');
var InsnList = Java.type('org.objectweb.asm.tree.InsnList');
var InsnNode = Java.type('org.objectweb.asm.tree.InsnNode');
var MethodInsnNode = Java.type('org.objectweb.asm.tree.MethodInsnNode');
var VarInsnNode = Java.type('org.objectweb.asm.tree.VarInsnNode');


var METHOD_PRERENDER = ASMAPI.mapMethod("func_77041_b");//preRenderCallback
var METHOD_PRERENDER_DESC = "(Lnet/minecraft/client/entity/player/AbstractClientPlayerEntity;F)V";
				
var NUM_FOUND = 0;


function log(message)
{
    print("[GenderCore-PlayerRenderer]: " + message);
}

function initializeCoreMod()
{
	return {
		"GenderCore-PlayerRenderer": {
			"target": {
				"type": "CLASS",
                'name': 'net.minecraft.client.renderer.entity.PlayerRenderer'
			},
			"transformer": function(classNode) {								
                for each (var method in classNode.methods) {					
                    if (method.name.equals(METHOD_PRERENDER) && method.desc.equals(METHOD_PRERENDER_DESC)) {
                        log("Transforming " + method.name + " in " + classNode.name);
    					NUM_FOUND++;
                        doPatchMethodNodeInClassNode(method);
                    } //else log("Did not match method DESC " + method.name + method.desc + " | target is: " + METHOD_PRERENDER + METHOD_PRERENDER_DESC);
                }                
                log("Found methods: "+NUM_FOUND+" of 1");                
				return classNode;
			}
		}
	};
}

function doPatchMethodNodeInClassNode(method)
{
    var toInject = new InsnList();
    toInject.add(new VarInsnNode(Opcodes.ALOAD, 1));
	toInject.add(new MethodInsnNode(Opcodes.INVOKESTATIC, "com/github/ipixeli/Gender/sides/client/render/RenderHooks", "playerPreRenderCallback", "(Lnet/minecraft/client/entity/player/AbstractClientPlayerEntity;)V"));
    toInject.add(new InsnNode(Opcodes.RETURN));
    method.instructions = toInject;
}